#include    "ksysdefs.h"
#include    "ksysvtyp.h"
#include    "kawkdefs.h"
/**/
#include	"ksysprot.h"
#include	"kawkfunc.h"
/**/
/*EXTERN*/
/*STATIC*/
/**/
#define	XUM		0
#define	EMOD	1
#define	EDIV	2
#define	EMUL	3
#define	EADD	4
#define	ESUB	5
#define	ELTE	6
#define	ELT		7
#define	EGTE	8
#define	EGT		9
#define	ENE		10
#define	EEQ		11
#define	XLNEG	12
void
pop1()
{
	dl = epop();
}
void
pop2()
{
	dr = epop();
	dl = epop();
}
void
xum()       /* unary minus */
{
	kfpmath(XUM);
}
void
ixum()
{
	dl.v.ivalu = - dl.v.ivalu;
}
void
dxum()
{
	dl.v.dvalu = - dl.v.dvalu;
}
void
emod()      /* stack add */
{
	kfpmath(EMOD);
}
void
iemod()
{
	if(dr.v.ivalu == 0)	divzero("modulo");
	dl.v.ivalu %= dr.v.ivalu;
}
void
demod()
{
	dr.v.ivalu = (int) dr.v.dvalu;
	dl.v.ivalu = (int) dl.v.dvalu;
	if(dr.v.ivalu == 0)	divzero("modulo");
	dl.v.ivalu %= dr.v.ivalu;
	dl.v.dvalu = (double) dl.v.ivalu;
}
void
ediv()      /* stack divide */
{
	kfpmath(EDIV);
}
void
iediv()
{
	if(dr.v.ivalu == 0)	divzero("division");
	dl.v.ivalu /= dr.v.ivalu;
}
void
dediv()
{
	if(dr.v.dvalu == (double) 0)	divzero("division");
	dl.v.dvalu /= dr.v.dvalu;
}
void
emul()      /* stack multiply */
{
	kfpmath(EMUL);
}
void
iemul()
{
	dl.v.ivalu *= dr.v.ivalu;
}
void
demul()
{
	dl.v.dvalu *= dr.v.dvalu;
}
void
mathassign(ty)	/* combined math and assign function */
int		ty;
{
	auto	DATUM	d0;
#ifdef	DEBUG
fprintf(stderr,"mathassign(%d)\n",ty);
query(stderr);
#endif	/*DEBUG*/
	d0 = epop();
	epush(d0);
	xeval();
	xswap();
	kfpmath(ty);
	epush(d0);
}
void
aemod()		/* add with assignment */
{
	mathassign(EMOD);
}
void
aediv()		/* add with assignment */
{
	mathassign(EDIV);
}
void
aemul()		/* add with assignment */
{
	mathassign(EMUL);
}
void
aesub()		/* add with assignment */
{
#ifdef	DEBUG
fprintf(stderr,"aesub()\n");
query(stderr);
#endif	/*DEBUG*/
	mathassign(ESUB);
}
void
aeadd()		/* add with assignment */
{
	mathassign(EADD);
}
void
eadd()      /* stack add */
{
	kfpmath(EADD);
}
void
ieadd()
{
	dl.v.ivalu += dr.v.ivalu;
}
void
deadd()
{
	dl.v.dvalu += dr.v.dvalu;
}
void
esub()      /* stack substraction */
{
	kfpmath(ESUB);
}
void
iesub()
{
	dl.v.ivalu -= dr.v.ivalu;
}
void
desub()
{
	dl.v.dvalu -= dr.v.dvalu;
}
void
elte()      /* stack less than or equal */
{
	kfpmath(ELTE);
}
void
ielte()
{
    dl.v.ivalu = dl.v.ivalu <= dr.v.ivalu;
}
void
delte()
{
    dl.v.ivalu = dl.v.dvalu <= dr.v.dvalu;
	dl.vtype = VINT;
}
void
elt()       /* stack less than */
{
	kfpmath(ELT);
}
void
ielt()
{
    dl.v.ivalu = dl.v.ivalu < dr.v.ivalu;
}
void
delt()
{
    dl.v.ivalu = dl.v.dvalu < dr.v.dvalu;
	dl.vtype = VINT;
}
void
egte()      /* stack greater than or equal */
{
	kfpmath(EGTE);
}
void
iegte()
{
    dl.v.ivalu = dl.v.ivalu >= dr.v.ivalu;
}
void
degte()
{
    dl.v.ivalu = dl.v.dvalu >= dr.v.dvalu;
	dl.vtype = VINT;
}
void
egt()       /* stack greater */
{
	kfpmath(EGT);
}
void
iegt()
{
    dl.v.ivalu = dl.v.ivalu > dr.v.ivalu;
}
void
degt()
{
    dl.v.ivalu = dl.v.dvalu > dr.v.dvalu;
	dl.vtype = VINT;
}
void
ene()       /* stack not equal */
{
	kfpmath(ENE);
}
void
iene()
{
    dl.v.ivalu = dl.v.ivalu != dr.v.ivalu;
}
void
dene()
{
    dl.v.ivalu = dl.v.dvalu != dr.v.dvalu;
	dl.vtype = VINT;
}
void
eeq()       /* stack equal */
{
	kfpmath(EEQ);
}
void
ieeq()
{
    dl.v.ivalu = dl.v.ivalu == dr.v.ivalu;
}
void
deeq()
{
    dl.v.ivalu = dl.v.dvalu == dr.v.dvalu;
	dl.vtype = VINT;
}
void
xlneg()
{
	kfpmath(XLNEG);
}
void
ixlneg()
{
    dl.v.ivalu = !(dl.v.ivalu);
}
void
dxlneg()
{
    dl.v.dvalu = !(dl.v.dvalu);
}
typedef	struct	MIXER	{
	FUNCP		pf;		/* pop function */
	FUNCP		fi;		/* function for integers */
	FUNCP		fd;		/* function for doubles */
	char	    *fn;	/* function name */
	}	MIXER;
static	MIXER	mix[] = {
	(FUNCP) pop1, (FUNCP) ixum, (FUNCP) dxum,"xum",
	(FUNCP) pop2, (FUNCP) iemod, (FUNCP) demod,"emod",
	(FUNCP) pop2, (FUNCP) iediv, (FUNCP) dediv,"ediv",
	(FUNCP) pop2, (FUNCP) iemul, (FUNCP) demul,"emul",
	(FUNCP) pop2, (FUNCP) ieadd, (FUNCP) deadd,"eadd",
	(FUNCP) pop2, (FUNCP) iesub, (FUNCP) desub,"esub",
	(FUNCP) pop2, (FUNCP) ielte, (FUNCP) delte,"elte",
	(FUNCP) pop2, (FUNCP) ielt, (FUNCP) delt,"elt",
	(FUNCP) pop2, (FUNCP) iegte, (FUNCP) degte,"egte",
	(FUNCP) pop2, (FUNCP) iegt, (FUNCP) degt,"egt",
	(FUNCP) pop2, (FUNCP) iene, (FUNCP) dene,"ene",
	(FUNCP) pop2, (FUNCP) ieeq, (FUNCP) deeq,"eeq",
	(FUNCP) pop1, (FUNCP) ixlneg, (FUNCP) dxlneg,"xlneg",
	}	;
/**/
void
kfpmath(nc)
NOSIGN	nc;
{
#ifdef	DEBUG
	fprintf(stderr,"kfpmath(%u) -> %s\n",nc,mix[nc].fn);
#endif
/**/
	(*mix[nc].pf)();		/* pop */
/**/
/*
*
*	for functions with two operands, check to see if either
*	is double AND the operands of different types.  if this
*	is the case, promote the !double operand to double.
*
*/
	if(mix[nc].pf == (FUNCP) pop2)	{
		if(dl.vtype != dr.vtype && (dl.vtype == VDOUBLE ||
			dr.vtype == VDOUBLE))	{
				if(dl.vtype == VDOUBLE)	{
					dr.v.dvalu = (double) dr.v.ivalu;
					dr.vtype = VDOUBLE;
					}
				else
				if(dr.vtype == VDOUBLE)	{
					dl.v.dvalu = (double) dl.v.ivalu;
					dr.vtype = VDOUBLE;
					}
				}
		}
	if(dl.vtype == VDOUBLE)	{
		(*mix[nc].fd)();	/* double function */
		}
	else	{
		(*mix[nc].fi)();	/* integer-pointer function */
		}
/**/
	epush(dl);
}
void
divzero(is)
char	*is;
{
	errmsg("<zero operand in %s>\n",is);
	terror(FUBAR);
	return;
}
