/*
============================================================
*	WARNING:  THIS ROUTINE IS VERY SENSITIVE TO SIGN
*	EXTENSION PROBLEMS AND SHOULD BE CHECKED FOR EACH
*	MACHINE AND COMPILER.
============================================================
*/
#include    "ksysdefs.h"
#include    "ksysvtyp.h"
/**/
#include	"keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"kedfuncs.h"
#include	"keyproto.h"
/**/
#include	"kedbuffr.h"
/**/
#define		NLST		16
#define		UMASK		'\377'
/**/
typedef		unsigned	long	ULONG;
/*
	must have ULONG, otherwise % (mod) bombs out on large
	values from crcsum();
*/
/*EXTERN*/
extern char *cpsx;
#ifdef	CAN_PROTO
extern void addbfcrc(char *, int);
extern void crcinit(void);
extern ULONG crcsum(void);
extern void errmsg(char *, ...);
extern int flagprt(FILE *, int, ...);
extern int hashmatch(char *, char *);
extern int hashword(char *, char *, char *);
extern void hhint(void);
extern int keylist(NOSIGN *, int, char *);
extern void printff(char *, ...);
#else	/*CAN_PROTO*/
extern void addbfcrc();
extern void crcinit();
extern ULONG crcsum();
extern void errmsg();
extern int flagprt();
extern int hashmatch();
extern int hashword();
extern void hhint();
extern int keylist();
extern void printff();
#endif	/*CAN_PROTO*/
/*STATIC*/
static	char		*hp;			/* pattern for hash search */
static	NOSIGN		list[NLST];		/* list of keys to hash */
static	NOSIGN		numl;			/* number of items in list */
static	NOSIGN		hx;				/* hash value for search */
/**/
void
hhint()
{
	khint("kedhash","");
	if(kenv.leisur & DA)	scr_cl(stdout);
	flagprt(stdout,kenv.buffer,"hashing","error display",NULL);
	hashprt(stdout);
	query(stdout);
	if(kenv.leisur & DA)	scr_cl(stdout);
}
/**/
envhash()			/* set hash functions from keyenv */
{
	auto	char	ws[FNMSIZ];
	auto	char	ps[FNMSIZ];
	auto	char	*wsx;
/*
**	get information for ".keys"; commands are the same as
**	if given interactively except that multiple commands
**	are indicated by breaking them with a pipe symbol
*/
/*
	POSSIBLE CONFLICT IF kenv.buffer USED FOR OTHER PURPOSES
*/
	numl = kenv.buffer = 0;
	if(!getdol(wsx = ws,ws+FNMSIZ-1,"hash"))	return(1);
	while((int)(wsx = xgnc(ps,ps+FNMSIZ-1,wsx,'|')))	sethash(ps);
	return(0);
}
cmdhash(argc,argv)	/* set hash functions from cmd line */
int		argc;
char	*argv[];
{
	auto	NOSIGN	i;
	for(i = 1; i < argc; i++)
	if(argv[i] &&
		strncmp(argv[i],"-H",2) == 0)	{
			sethash(argv[i]);
			argv[i] = NULL;
		}
	return(0);
}
void
sethash(is)		/* set hash function options */
char	*is;
{
	while(*is != ZERO)
	if(isspace(*is))				++is;
	else
	if(*is == 'H' || *is == '-')	++is;
	else							break;
	switch(*is)	{
	case	'p':	hashprt(stdout);
	when	ZERO:
	case	'?':
	default:		hhint();
	when	'g':	dohash(1,cdx.lst,is);
	when	'e':	kenv.buffer |= DB;
	when	'E':	kenv.buffer &= ~DB;
	when	'h':	kenv.buffer |= DA;
	when	'H':	kenv.buffer &= ~DA;
	when	'k':	numl = keylist(list,NLST,strcnd(is+1));
					if(numl <= 0)	kenv.buffer &= ~DA;
					else			kenv.buffer = DA | DB;
					break;
	}
	return;
}
hashprt(fp)	/* print keys to be hashed */
FILE	*fp;
{
	auto	NOSIGN	i;
	for(i = 0; i < numl; i++)	{
		fprintf(fp,"%s\n",kd[list[i]].label);
	}
	if(numl <= 0)	fprintf(fp,"\007<NO LIST>\007\n");
	return(numl);
}
/**/
NOSIGN
cdhash(nc,ty)	/* scan a card for keys to be hashed */
int		nc;		/* card number */
int		ty;		/* I-O type */
{
	REG		NOSIGN	i;
	REG		NOSIGN	nfld = numl;
	auto	NOSIGN	hash = 0;
	auto	char	*os;
/**/
	if(ty == LINE_IO)	{
		clcd();
		xtocd(kb.base,'o');
		}
	else
	if(ty == CARD_IO)	;
	else				dump("cdhash: ty");
/**/
	for(i = 0; i < nfld; i++)	{
		os = kd[list[i]].data;
		if(os)	{
			hash = strhash(os);
			return(hash);
			}
	}
/**/
	if(kenv.buffer & DB)	{
		errmsg("cdhash <not hashed> %u\n",nc);
		}
/**/
	return(hash);
}
dohash(n1,n2,is)	/* force hash of current file */
int		n1;
int		n2;
char	*is;
{
	auto	NOSIGN	i;
/**/
	if(numl <= 0 || !(kenv.buffer & DA))	{
		hhint();
		return;
		}
/**/
	for(i = n1; i <= n2; i++)	{
		getcd(i,CARD_IO);
		cdhash(i,CARD_IO);
		}
/**/
	return;
}
pullh(is)		/* pull hash pattern */
char	*is;
{
	auto	char	ws[FNMSIZ];
	if(is[1] == ZERO || is[0] == is[1])	{
		while(*is == '%')	++is;
		cpsx = is;
		if(hp)	return(0);
		else	{
			errmsg("pullh <no previous hash pattern>\n");
			terror(FUBAR);
			}
	}
/**/
	cpsx = xgnc(ws,ws+FNMSIZ-1,cpsx = is + 1, *is);
	hx = strhash(ws);
	hp = stringer(ws,hp);
/**/
	return(0);
}
findh(ty)
int		ty;
{
	auto	int		cur = cdx.cur;
	auto	int		dot = cdx.cur;
/**/
	do  {
		dot = (dot < cdx.lst) ? ++dot : 1;
		if(re_hash(dot))	{
			return(dot);
			}
		}
	while(dot != cur) ;
/**/
	if(!cdx.glb && kenv.prompt)
		printff("<no match>\n");
/**/
	return(cdx.con = dot);
}
re_hash(nc)
int		nc;
{
	auto	NOSIGN	hz = cbt[nc].tags.hash;
	auto	NOSIGN	nr = 0;
	auto	NOSIGN	i;
	auto	NOSIGN	hf;
	auto	char	*os;
/**/
	hz &= UMASK;
/**/
#ifdef	DEBUG
	fprintf(stderr,"re_hash(%u,%u,%u)\n",nc,hz,hx);
	query(stderr);
#endif	/*DEBUG*/
/**/
	if(hz != hx)	return( nr );		/* no hope */
/**/
	getcd(nc,CARD_IO);
/**/
	for(i = 0; i < numl; i++)	{
		os = kd[list[i]].data;
#ifdef	DEBUG
	fprintf(stderr,"i %d ",i);
	fprintf(stderr,"list[i] %d ",list[i]);
	fprintf(stderr,"skey %s ",kd[list[i]].skey);
	fprintf(stderr,"os %s ",kd[list[i]].data);
	fprintf(stderr,"\n");
#endif	/*DEBUG*/
		if(os)	{
			hf = hashmatch(os,hp);
			return(hf);
			}
	}
/**/
	return(nr);
}
hashmatch(os,is)
char	*os;
char	*is;
{
	auto	char	ls[FNMSIZ];
	auto	char	rs[FNMSIZ];
	auto	int		nls;
	auto	int		nrs;
/*
	make sure the fields to be compared have been processed with
	the same exclusions and limits.
*/
	nls = hashword(ls,ls+FNMSIZ-1,os);
	nrs = hashword(rs,rs+FNMSIZ-1,is);
#ifdef	DEBUG
	fprintf(stderr,"hasmatch(%s,%s)\n",ls,rs);
#endif	/*DEBUG*/
	if(nls == nrs)	return(!strcmp(ls,rs));
	else			return( 0 );
}
NOSIGN
strhash(is)
char	*is;
{
	auto	char	ws[FNMSIZ];
	auto	int		nc;
	auto	ULONG	lhash;
	auto	NOSIGN	uhash;
/*
	is the crc function worth all this overhead?
*/
	crcinit();
	nc = hashword(ws,ws+FNMSIZ-1,is);
	addbfcrc(ws,nc);
	lhash = crcsum();
	lhash = lhash % (ULONG	) MODFAC;
	uhash = (NOSIGN) lhash;
	uhash &= UMASK;
#ifdef	DEBUG
	fprintf(stderr,"strhash(%s,%lu,%u)\n",ws,lhash,uhash);
	query(stderr);
#endif	/*DEBUG*/
	return( uhash );
}
hashword(os,us,is)
char	*os;
char	*us;
char	*is;
{
	auto	char	*isx = is;
	auto	char	*osx = os;
	auto	char	*usx = us;
	auto	NOSIGN	ncc = 0;
/*
	pull a "word" for hashing. a word is alphanumeric items only. if there
	are not enough characters in the first word, continue.
*/
	*osx = 0;
	while(*isx != 0 && osx < usx)
	if(isalnum(*isx))				{
/*
	brain-dead tolower() in SUN fucks things up if character is not
	upper case.
*/
		if(isupper(*isx)) 	*osx++ = tolower(*isx);
		else				*osx++ = *isx;
		isx += 1;
		ncc += 1;
		}
	else
	if(isspace(*isx) && ncc >= 4)	break;
	else							isx += 1;
	*osx = 0;
/**/
#ifdef	DEBUG
	fprintf(stderr,"hashword(%s,%s)\n",os,is);
	query(stderr);
#endif	/*DEBUG*/
/**/
	return( ncc );
}
