#define		DEBUG
#undef		DEBUG
/*
	interface between ked and vi
*/
/*
*/
#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"keddefs.h"
#include	"kedvars.h"
#include	"ksysprot.h"
#include	"keyproto.h"
/**/
/*EXTERNAL*/
extern	KENV	kenv;
/*GLOBAL*/
/*STATIC*/
static	char		*visual;		/* visual editor */
static	char		*tmpdir;		/* temporary directory */
static	FILE		*vfp;			/* visual work file */
static	char		vfn[FNMSIZ];	/* visual work file name */
static	char		*ltc;			/* line termination */
static	char		cmd[FNMSIZ];	/* call to visual */
static	int			hinted;			/* hint function called */
/**/
#ifndef		KEYSIZ	
#define		KEYSIZ	32
#endif
#define		VI_OKAY		0
#define		VI_RDERR	1
#define		VI_STOP		2
/**/
void
kdovi(n1,n2,is)		/* call vi for specified cards */
char	*is;
int		n1;
int		n2;
{
	auto	int		vir;
	auto	int		i;
	auto	int		lo = 1;
	auto	int		dc = 0;
	auto	char	*ps = NULL;		/* pattern string */
	auto	char	*fs = NULL;
/**/
	if(!isatty(0))		terror(FUBAR);
/**/
	if(visual == NULL)	{
		visual = kgetenv("VISUAL");
		if(isnull(visual))	{
			if(kenv.dosdos)	visual = "c:/bin/vi.exe";
#ifdef	M_XENIX
			else			visual = "/bin/vi";
#else	/*M_XENIX*/
			else			visual = "/usr/ucb/vi";
#endif	/*M_XENIX*/
			}
		visual = strsave(visual);
		}
	if(access(visual,01))	{
		errmsg("kdovi <cannot find> '%s'\n",visual);
		terror(FUBAR);
		}
/**/
	if(hinted == 0)	{
		hinted = 1;
		vihint();
		}
/**/
	tmpdir = kgetenv("TMPDIR");
	if(tmpdir == NULL)	tmpdir = ".";
/**/
	strcpy(vfn,tmpdir);
	strcat(vfn,"/kvXXXXXX.tmp");
	maketemp(vfn);
/**/
/*	change always assumed */
	cdx.chg += 1;
	cdx.del += 1;
/**/
	if(*is == 'V')	is += 1;
	fs = isnull(is) ? NULL : is;
/**/
	for(i = n1; lo && i <= n2; i++)		{
/**/
		if(!(vfp = efopen(vfn,"w")))	terror(FUBAR);
		getcd(i,LINE_IO);
		xsfwrcd(kb.base,vfp,kenv.folder);
/**/
			for( ; lo ; )	{
				vfp = xfclose(vfp);
				if(fs)	sprintf(cmd,"%s '+%s' %s",visual,fs,vfn);
				else
				if(ps)	sprintf(cmd,"%s '+/^.%s/' %s",visual,ps,vfn);
				else	sprintf(cmd,"%s +1 %s",visual,vfn);
				fs = NULL;
#ifdef	DEBUG
	fprintf(stderr,"cmd(%s)\n",cmd);
	query(stderr);
#endif	/*DEBUG*/
				if(gofork(cmd))	{
					errmsg("kdovi <command failed>\n%s\n",cmd);
					terror(FUBAR);
					}
				if(!(vfp = efopen(vfn,"r")))	terror(FUBAR);
/**/
				vir = virdcd(vfp);
/**/
				if(vir == VI_OKAY)	break;
				else
				if(vir == VI_STOP)	{
					lo = 0;
					cdx.glb = 0;
					break;
					}
/**/
				ps = rderr(NULL);
/**/
			}
		vfp = xfclose(vfp);
/**/
		if(nullcd())	{
			printff("\007<card deleted>\n");
			dc += 1;
			delcd(i,i,"");
			n2 -= 1;
			}
		else	{
			cdcond();
			chgcd(i,CARD_IO);
			prlist(i,i,is);
			}
		}
/**/
	unlink(vfn);
/**/
	if(dc)	printff("%d fewer card(s) after visual\n",dc);
	return;
}
virdcd(fp)			/* read card in sharp format */
FILE	*fp;
{
	auto	char	*osx = kb.base;
	auto	char	*usx = kb.bmax;
	auto	char	*rsx = NULL;
	if(kb.base == NULL)	dump("kb.base is null");
#ifdef	DEBUG
	fprintf(stderr,"virdcd()\n");
	query(stderr);
#endif	/*DEBUG*/
	while( rsx = fgetlf(osx,usx,fp))	{
		while(*osx == '#')	*osx++ = LF;
		*rsx++ = ' ';
		osx = rsx;
		*osx = ZERO;
		}
	clcd();
#ifdef	DEBUG
	xwrcd(kb.base,stderr);
	query(stderr);
#endif	/*DEBUG*/
	if(xtocd(kb.base,'v') == 0)	{
		if(strcmp(rderr(NULL),"STOP") == 0)	return(VI_STOP);
		errmsg("virdcd <unknown or redefined key> '%s'\n",
			rderr(NULL));
		query(stderr);
		return(VI_RDERR);
		}
#ifdef	DEBUG
	wrcd(stdout,'f',56);
#endif	/*DEBUG*/
	return(VI_OKAY);
}
void
xsfwrcd(os,fp,fw)		/* write card in sharp format, folded */
char	*os;
FILE	*fp;
int		fw;
{
	auto	char	*osx = os;
	auto	char	*lsx;
	auto	int		pw = 0;
	fw = fw ? fw : 56;
	while(isspace(*osx))	++osx;
	/* fputs("##\n",fp); */
	if(*osx != LF)	fputs("#",fp);
	while(*osx != 0)	{
		if(*osx == LF)	{
			while(isspace(*osx))	++osx;
			if(*osx == NULL)		break;
			fputs("\n#",fp);
			pw = 0;
			}
		else
		if(isspace(*osx) && pw >= fw)	{
			fputs("\n",fp);
			pw = 0;
			while(isspace(*osx))	++osx;
			}
		else	{
			fputc(*osx++,fp);
			pw += 1;
			}
		}
	fputs("\n",fp);
	fflush(fp);
	return;
}
static	char	*vix[] = {
	"=",
	"*       to return to ked, type :wq",
	"*",
	"*       to end a series of calls to the visual editor",
	"*       place #STOP at the END of the current card.",
	"=",
	}	;
vihint()
{
	prhint( vix, sizeof(vix)/sizeof(char*), 0, 0);
	return(0);
}
