#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include    "kroffvar.h"
/**/
#ifndef     DPI
#define     DPI     5
#endif
/**/
/*EXTERNAL*/
/*
**  basic commands
*/
xnv(nvc,is) /* change environment */
char    *is;
{
	auto    int nvx;
	nvx = setvar(nv,is,ABSO,nvc,0);
	if(nvx >= NENV || nvx < 0)  {
		errmsg("xnv: <bad nv> '%d'\n",nvx);
		terror(FUBAR);
	}
	return(nv = nvx);
}
xsh(nv,is)  /* fork shell */
char    *is;
{
	alarm(120);
	strcnd(is);
	if(isnull(is))  return(alarm(0),system("sh"));
	else            return(alarm(0),system(is));
}
/*
**  variable setting routines below
*/
xcc(nv,is)
char    *is;
{
	strcnd(is);
	if(isnull(is))  x[nv].cc = DCC;
	else            x[nv].cc = *is;
	return;
}
xc2(nv,is)
char    *is;
{
	strcnd(is);
	if(isnull(is))  x[nv].c2 = DC2;
	else            x[nv].c2 = *is;
	return;
}
xpo(nv,is)
char    *is;
{
	x[nv].po = setvar(nv,is,HORZ,x[nv].po,DPO);
	return;
}
xti(nv,is)
char    *is;
{
	if(x[nv].br >= 1 && x[nv].osx > x[nv].osx)   xbr(nv,is);
	x[nv].br = 0;
	x[nv].ti = setvar(nv,is,HORZ,x[nv].ti,DTI);
	return;
}
xin(nv,is)
char    *is;
{
	if(x[nv].br >= 1 && x[nv].osx > x[nv].osx)   xbr(nv,is);
	x[nv].br = 0;
	x[nv].in = setvar(nv,is,HORZ,x[nv].in,DPI);
	return;
}
xll(nv,is)
char    *is;
{
	x[nv].ll = setvar(nv,is,HORZ,x[nv].ll,DLL);
	return;
}
xpl(nv,is)
char    *is;
{
	x[nv].pl = setvar(nv,is,VERT,x[nv].pl,DPL);
	badtrap( x[nv].pl * 2 );
	return;
}
xpn(nv,is)
char    *is;
{
/*DEFAULT?*/
	x[nv].pn = setvar(nv,is,ABSO,x[nv].pn,1);
	return;
}
/*
**  miscellaneous functions
*/
static          char    *pp[5];     /* for parsing */
/*
*/
xge(nv,is)      /* get environment variable */
char    *is;
{
	auto    char    *ev;
/*
**  [ets] variable name
**  0       1       2
*/
	savecmd(is);
	getqs(pp,5,is);
	if(!(ev = getenv(pp[1])))   {
		errmsg("xge <unknown variable> '%s'\n",pp[1]);
		terror(FUBAR);
		}
	switch(*pp[0])  {
	case    'e':    fputut(ev,stderr,0);
					putc('\n',stderr);
					break;
	case    's':    mdefine(pp[2],ev,'$');
					break;
	default:
	case    't':    isolate(nv,ev,1);
					break;
	}
	savecmd("");
	return(0);
}
/*
*/
xta(nv,is)      /* set tab expansion width */
char	*is;
{
	return(x[nv].ta = zta(setvar(nv,is,HORZ,x[nv].ta,4)));
}
xtc(nv,is)      /* set tab char for tab expand */
char    *is;
{
	if(isnull(is))  x[nv].tc = ztc('\t');
	else            x[nv].tc = ztc(*is);
	return(x[nv].tc);
}
xlc(nv,is)      /* set tab expansion character */
char    *is;
{
	if(isnull(is))  x[nv].lc = zlc(' ');
	else            x[nv].lc = zlc(*is);
	return(x[nv].lc);
}
/*
*/
/*
**  translation function
*/
#ifdef		ASCII
#undef		ASCII
#endif
#define         ASCII       128
static          char    tr[ASCII];
static          int     on = 0;
/*
*/
xtr(nv,is)              /* set translation function */
char    *is;
{
	REG     int     i;
	REG     char    *cx;
	while(isspace(*is)) ++is;
	if(isnull(is))  return(on = 0);
	getqs(pp,2,is);
	for(i = 0; i < ASCII; i++)  tr[i] = (char) i;
	for(cx = pp[0]; *cx != ZERO; cx += 2)   {
	if(cx[1] == ZERO)   tr[cx[0]] = ' ';
	else                tr[cx[0]] = cx[1];
	}
	return(x[nv].tr = on = 1);
}
char	*
ztr(nv,is)              /* do character translation */
char    *is;
{
	REG     char    *isx = is;
	if(on)  {
		while(*isx != ZERO) {
			*isx = tr[*isx];
			isx += 1;
		}
	}
	return(is);
}
char	*
savecmd(is)         /* save command for diagnostics */
char    *is;
{
	static  char	lc[BLKSIZ];
	if(isnull(is))	return(lc);
	return(strkat(lc,&lc[BLKSIZ-1],is));
}
xdb(nv,is)              /* set debub level */
char    *is;
{
	db = setvar(nv,is,ABSO,db,1);
	return(db);
}
xdt(nv,is)              /* set date macro */
char    *is;
{
	auto	char    ws[FNMSIZ];
	auto	char    *wsu = ws + FNMSIZ -1;
/**/
	if(isnull(is))  strtime(ws,wsu,"%M %d, %Y",0L);
	else            strtime(ws,wsu,is,0L);
/**/
	mdefine("DT",ws,'$');
/**/
	return(ZERO);
}
overflow(nv,is,ty)
char    *is;
{
	errmsg("<overflow in> '%s'\n",is);
	terror(ty);
	return(ty);
}
nocore(nv,is,ty)
char    *is;
{
	errmsg("<no core in> '%s'\n",is);
	terror(ty);
	return(ty);
}
badeof(nv,is,ty)
char    *is;
{
	errmsg("<unexpected eof in> '%s'\n",is);
	terror(ty);
	return(ty);
}
badenv(nv,is,ty)
char    *is;
{
	errmsg("<illegal command for environment> '%s'\n",is);
	terror(ty);
	return(ty);
}
xpx(nv,is)		/* paragraph indent */
char    *is;
{
	return(x[nv].px = setvar(nv,is,VERT,x[nv].px,DPD));
}
xpd(nv,is)		/* paragraph separation (distance) */
char    *is;
{
	return(x[nv].pd = setvar(nv,is,VERT,x[nv].pd,DPD));
}
xhp(nv,is)		/* horizontal position */
char    *is;
{
	return(x[nv].hp = setvar(nv,is,HORZ,x[nv].hp,0));
}
abm(is)		/* abort message */
char	*is;
{
	auto	char	cx;
	cx = '\n';
	write(2,&cx,1);
	write(2,is,strlen(is));
	cx = '\n';
	write(2,&cx,1);
	return(0);
}
