#include	"ksysdefs.h"
#include	"ksysvtyp.h"
#include	"ksysprot.h"
#include	"kroffdef.h"
#include	"kroffvar.h"
#define		memnull(a,b)memset(a,0,b)
/*
**	10.02:87	converted to used proprietary tgetent
*/
#define     TERMBUF     1024
#define		NEGONE		-1
#define		MASK		'\100'
#define		FLAG		'^'
/*EXTERNAL*/
/*STATIC*/
static      int     dumb;
static      int     quick = 0;      /* quick movement right */
static      int     worst = 0;      /* worst case for quick */
static      int     pf = FOR;   	/* last font */
static      char    fns[32];        /* foonote format */
/**/
/**/
static      char    *tcodes = NULL;
static      struct  KTERM
{
	char    *CE;                /* clear line */
	char    *CH;                /* cursor horz. */
	char    *CL;                /* clear screen */
	char    *CM;                /* cursor mvt. */
	int     CO;                 /* columns */
	char    *DL;                /* delete line */
	char    *DO;                /* down one line */
	char    *FB;                /* bold font */
	char    *FF;                /* form (page) feed */
	char    *FI;                /* italic font */
	char    *FR;                /* roman font */
	char    FT;                 /* font must be toggled */
	char    *FU;                /* underline font */
	char    *HD;                /* half down */
	char    *HU;                /* half up */
	char    *IS;                /* initialization */
	char    *LC;                /* */
	int     LI;                 /* lines */
	char	*OV;				/* overstruck vowels */
	char    *RC;                /* right cursor */
	char    *SE;                /* !standout */
	char    *SO;                /* standout */
	char    *UE;                /* !underscore */
	char    *UP;                /* upline (reverse line feed) */
	char    *US;                /* underscore */
	char    *VE;                /* visual end */
	char    *VS;                /* visual start */
}   kt;
/**/
ttset(tt)           /* get codes for tty = tt */
char    *tt;
{
	auto	int		ret;
/**/
	ret = ttget(tt);
	if(ret)				return(ret);
/**/
	if(isnull(kt.FB))   dumb = 1;
	else                dumb = 0;
/*
**  determine overstruck vowel format
*/
	if(isnull(kt.OV))	overvowel(xesc("_\ba _\be _\bi _\bo _\bu"));
	else				overvowel(kt.OV);
/*
**  determine footnote format
*/
	strcpy(fns,"[%d]");
	if(!isnull(kt.HU))  strcpy(fns,"\\u%d\\d");
	else
	if(!isnull(kt.FB))  strcpy(fns,"\\FB%d\\FR");
	return(0);
}
overvowel(is)		/* set vowel over strikes */
char	*is;
{
	auto	int		np;
	auto	char	*os;
	extern	char	*vowel[];
	os = strsave(is);
	np = splitc(vowel,5,os,' ');
	if(np != 5)	{
		errmsg("overvowel <bad string>\n");
		terror(FUBAR);
		}
	return(np);
}
ttget(tt)
char	*tt;
{
	auto	char    bp[TERMBUF];
	auto	char    *bx = tcodes;
	auto	char	*zx;
	pf = FOR;
	dumb = quick = worst = 0;
	if(isnull(tt))                tt = getenv("TERM");
	if(isnull(tt))								{
		errmsg("<no TERM variable>\n");
		return(1);
		}
/**/
	zx = strchr(tt,':');
	if(zx)	*zx = ZERO;
/**/
/*
	the msdos version has dummies
*/
	if(tgetent(bp,bp+TERMBUF-1,tt))		{
		errmsg("<cannot set TERM>\n");
		return(2);
		}
/**/
/*===CHECK===*/
	bx = tcodes = emalloc(BLKSIZ,"ttget");
	memnull(bx, BLKSIZ );
/**/
	kt.CE = zgetstr("ce",&bx);
	kt.CH = zgetstr("ch",&bx);
	kt.CL = zgetstr("cl",&bx);
	kt.CM = zgetstr("cm",&bx);
	kt.CO = tgetnum("co");
	kt.DL = zgetstr("dl",&bx);
	kt.DO = zgetstr("do",&bx);
	kt.FB = zgetstr("fB",&bx);
	kt.FF = zgetstr("ff",&bx);
	kt.FI = zgetstr("fI",&bx);
	kt.FR = zgetstr("fR",&bx);
	kt.FT = tgetflag("tt",&bx);
	kt.HD = zgetstr("hd",&bx);
	kt.HU = zgetstr("hu",&bx);
	kt.IS = zgetstr("is",&bx);
	kt.LC = zgetstr("lc",&bx);
	kt.LI = tgetnum("li");
	kt.OV = tgetstr("OV",&bx);
	kt.RC = zgetstr("rc",&bx);
	kt.SE = zgetstr("se",&bx);
	kt.SO = zgetstr("so",&bx);
	kt.UE = zgetstr("ue",&bx);
	kt.UP = zgetstr("up",&bx);
	kt.US = zgetstr("us",&bx);
	kt.VE = zgetstr("ve",&bx);
	kt.VS = zgetstr("vs",&bx);
	if(kt.FB == NULL)  kt.FB = kt.SO;
	if(kt.FI == NULL)  kt.FI = kt.US;
	if(kt.FU == NULL)  kt.FU = kt.US;
	if(kt.FR == NULL)  kt.FR = kt.SE;
	return(0);
}
char	*
zgetstr(os,is)
char	*os;
char	**is;
{
	return(nopad(tgetstr(os,is)));
}
char	*
nopad(is)				/* strip padding information */
char	*is;
{
	register	char	*isx = is;
	if(isx == (char *) NEGONE)		return(NULL);
	if(isnull(isx))					return(NULL);
	while(isdigit(*isx))			++isx;
	if(*isx == '/')					++isx;
	return(isx);
}
ttce(fp)               /* erase to end of line */
FILE    *fp;
{
	if(isatty(fileno(fp)))
		{
		putc('\015',fp);
		if(kt.CE)   {
			fputs(kt.CE,fp);
			}
		fflush(fp);
		return(YES);
		}
	else    return(NO);
}
ttrst(fp)               /* reset terminal */
FILE    *fp;
{
	if(isatty(fileno(fp)))
		{
		if(kt.VE)   fputs(kt.VE,fp);
		if(kt.FR)   fputs(kt.FR,fp);
		fflush(fp);
		return(YES);
		}
	else    return(NO);
}
ttclr(fp)               /* clear terminal */
FILE    *fp;
{
	if(isatty(fileno(fp)))
		{
		if(kt.VE)   fputs(kt.VE,fp);
		if(kt.CL)   fputs(kt.CL,fp);
		if(kt.FR)   fputs(kt.FR,fp);
		fflush(fp);
		return(YES);
		}
	else    return(NO);
}
char    *
ttfns()                 /* footnote format */
{
	return(fns);
}
isdumb()
{
	return(!dumb);
}
font_change(fp,df)
FILE    *fp;
{
	static  int 	lf = FUBAR;
	if(df == lf)    return(df);
	switch(df) {
	case    FOB:    if(kt.FB)	fputs(kt.FB,fp);
	when    FOI:    if(kt.FI)	fputs(kt.FI,fp);
	when    FOR:    if(kt.FR)	fputs(kt.FR,fp);
	when    FOU:    if(kt.FU)	fputs(kt.FU,fp);
	default:        break;
	}
	return(lf = df);
}
fputut(is,fp,po)        /* write to terminal */
char    *is;
FILE    *fp;
int		po;
{
	REG     unsigned	char    *isx;
	REG     int     	nsx = 0;
	auto    int     	cf = FOR;
/*
*/
	while(po-- >= 1)	putc(' ',fp);
/*
*/
	for(isx = is; *isx != ZERO; ++isx)
	switch(*isx)	{
	case    ZRO:    break;
	case	' ':
	case    ZSP:	putc(' ',fp);
					break;
	case    WORD:   nsx = *++isx;
					while(nsx-- >= 1)	putc(' ',fp);
					break;
	case    STOP:
					break;
	case    THP:    break;
	case    BSP:    putc(*isx,fp);
					break;
/*
**  nroff
**  \r      VRV         kt.UP
**  \u      VUP         kt.HU
**  \d      VDO         kt.HD
**          DWN         kt.DO
*/
	case    VRV:    if(kt.UP)	fputs(kt.UP,fp);
					break;
	case    VUP:    if(kt.HU)	fputs(kt.HU,fp);
					break;
	case    VDO:    if(kt.HD)	fputs(kt.HD,fp);
					break;
	case    DWN:    if(kt.DO)	fputs(kt.DO,fp);
					break;
	case    FOB:    pf = cf = font_change(fp,FOB);
					break;
	case    FOI:    pf = cf = font_change(fp,FOI);
					break;
	case    FOR:    pf = cf = font_change(fp,FOR);
					break;
	case    FOU:    pf = cf = font_change(fp,FOU);
					break;
	default:        if(*isx < ' ')  continue;
					if(dumb && cf != FOR)   {
						if(cf != FOU && isspace(*isx)) ;
						else    {
							putc('_',fp);
							putc('\b',fp);
							}
						}
					putc(*isx,fp);
					break;
	}
/*  always end lines "roman" */
	if(cf != FOR)   pf = font_change(fp,FOR);
	return(cf);
}
